//===============================================================================
// Copyright 2014 Alachisoft.  All rights reserved.
//===============================================================================

using System;
using System.Collections;
using System.Collections.Generic;

using Alachisoft.NCache.Caching.AutoExpiration;
using Alachisoft.NCache.Caching.EvictionPolicies;
using Alachisoft.NCache.Runtime.DatasourceProviders;
using Alachisoft.NCache.Runtime.Caching;

using Directory.Business;
using Directory.Utility;

namespace Directory.Providers
{
	/// <summary>
	/// Contains methods used to read an object by its key from the master data source. 
	/// </summary>
	public class XmlReadThruProvider : Alachisoft.NCache.Runtime.DatasourceProviders.IReadThruProvider
	{
        /// <summary>
        /// Responsible for loading the object from the external data source. 
        /// Key is passed as parameter.
        /// </summary>
        /// <param name="key">item identifier; probably a primary key</param>
        /// <param name="cacheItem">It is used to provide CacheItem information like Cache policies, dependencies, expirations ...</param>
		public void LoadFromSource(string key, out ProviderCacheItem cacheItem)
		{	
			cacheItem = new ProviderCacheItem(XmlDataSource.LoadCustomer(key));
		}

        /// <summary>
        /// 
        /// </summary>
        /// <param name="keys[]"></param>
        /// <returns></returns>
        public Dictionary<string, ProviderCacheItem> LoadFromSource(string[] keys)
        {
            throw new Exception("The method or operation is not implemented.");
        }

		/// <summary>
		/// Perform tasks like allocating resources or acquiring connections
		/// </summary>
		/// <param name="parameters">Startup paramters defined in the configuration</param>
        /// <param name="cacheId">Define for which cache provider is configured</param>
		public void Init(IDictionary parameters, string cacheId)
		{
			XmlDataSource.Connect();
		}

		/// <summary>
		///  Perform tasks associated with freeing, releasing, or resetting resources.
		/// </summary>
		public void Dispose()
		{
			XmlDataSource.DisConnect();
		}
    }
	
}  
